##undirected graph without selfloops

rm(list=ls())
#install.packages("mclust")
require(mclust)
#data generation
n = 100
kk = 2
Z <- c(sample(1:kk, size = kk, replace = FALSE),
       sample(1:kk, size = n-kk, replace = TRUE,prob = c(1,1)))
Z = Z[order(Z)]
theta <- matrix(0.1,kk,kk)
diag(theta) = 0.225
A = matrix(0,n,n)
AAA = matrix(0,n,n)
for (i in 1:n){
  for (j in i:n){
    A[i,j] = rbinom(1,1,prob=theta[Z[i],Z[j]])
    A[j,i] = A[i,j]
    AAA[i,j] = A[i,j]
  }
}
diag(AAA) = 0
diag(A) = 0

A_52004U = A
AAA_52004U = AAA
Z_52004U = Z
#precomputation for the V function
lambda <- 1
gamma <- 1
N=n
VN<-0
tmax = n+10
for (t in 1:tmax)
{
  r = log(0)
  for (k in t:500)
  {
    b = sum(log((k-t+1):k))-sum(log((k*gamma):(k*gamma+N-1))) + dpois(k-1, lambda, log = TRUE)
    m = max(b,r)
    r = log(exp(r-m) + exp(b-m)) + m
  }
  VN[t] = r
}


#function for getting m(Aj) need to modify the clusterassign part
loglike <- function(clusterassign,param,data,J,n) #here J means Jth observation
{
  clustersize = max(clusterassign)
  param = as.matrix(param)
  
  if (J==1) {result2 = 0
             for (ii in c((J+1):n))
             {
               result2 = result2 + data[J,ii]*log(param[clusterassign[J],clusterassign[ii]])+(1-data[J,ii])*log(1-param[clusterassign[J],clusterassign[ii]])
             }
             output = sum(result2)} else if (J==n){
               result = 0
               for (ii in c(1:(J-1)))
               {
                 result = result + data[ii,J]*log(param[clusterassign[ii],clusterassign[J]])+(1-data[ii,J])*log(1-param[clusterassign[ii],clusterassign[J]])
               }
               output = sum(result)
             } else {
  result = 0
  for (ii in c(1:(J-1)))
  {
    result = result + data[ii,J]*log(param[clusterassign[ii],clusterassign[J]])+(1-data[ii,J])*log(1-param[clusterassign[ii],clusterassign[J]])
  }
  
  result2 = 0
  for (ii in c((J+1):n))
    
  {
    result2 = result2 + data[J,ii]*log(param[clusterassign[J],clusterassign[ii]])+(1-data[J,ii])*log(1-param[clusterassign[J],clusterassign[ii]])
  }
  output = sum(result)+sum(result2)}
 output
}

#function for getting m(Aj) need to modify the clusterassign part
logmargs <- function(clusterassign,data,J,beta.a,beta.b) #here J means Jth observation
{
  clustersize = max(clusterassign)-1
  result = NULL
  for (ii in 1:clustersize)
  {
    sumA =  sum(data[J,which(clusterassign==ii)[which(clusterassign==ii)>J]]) + sum(data[which(clusterassign==ii)[which(clusterassign==ii)<J],J])
    S = length(which(clusterassign==ii)[which(clusterassign==ii)>J]) + length(which(clusterassign==ii)[which(clusterassign==ii)<J])
    result[ii] = lbeta(sumA+beta.a,S-sumA+beta.b)-lbeta(beta.a,beta.b)
  }
  sum(result)
}


CDMFM_new <- function(data, data1, niterations = 150, beta.a = 1, beta.b = 1, VN, GAMMA=1,initNClusters)
{
  n = dim(data)[1]
  # initialization
  clusterAssign <- c(sample(1:initNClusters, size = initNClusters, replace = FALSE),
                     sample(1:initNClusters, size = n-initNClusters, replace = TRUE))
  
  Q<-matrix(0, initNClusters,initNClusters)
  for (i in 1:initNClusters){
    for (j in i:initNClusters){
      Q[i,j] = rbeta(1,beta.a,beta.b)
      Q[j,i] = Q[i,j]
    }
  }
  History <- vector("list", niterations)
  ######################################################################
  ##Algorithm
  for (iter in 1:niterations)
  {
    #theta <- cParam$theta
    clusterSizes = table(as.factor(clusterAssign))
    nClusters = length(clusterSizes)
    for (i in 1:n)
    { #determine whether ith component is a singleton 
      cur.cluster.i = clusterAssign[i]
      if (clusterSizes[clusterAssign[i]] > 1){
        # not a singleton, have |C|+1 choices
        c.counts.noi = clusterSizes  #c.counts.noi corresponds to |C|
        c.counts.noi[clusterAssign[i]] = c.counts.noi[clusterAssign[i]] - 1
        #finding the probs for sampling process
        clusterProbs = sapply(1:nClusters, function(x) {
          clusterAssign_temp = clusterAssign
          clusterAssign_temp[i] = x
          (GAMMA+c.counts.noi[x])*exp(loglike(clusterAssign_temp,Q,data,i,n))
        })
        clusterAssign_1 = clusterAssign
        clusterAssign_1[i] = nClusters+1
        clusterProbs[nClusters+1]<-GAMMA*exp(logmargs(clusterAssign_1,data,i,beta.a,beta.b))*exp(VN[nClusters+1]-VN[nClusters])
        #choose the cluster number for ith observation
        cluster.i <- sample(1:(nClusters+1), size = 1,
                            prob = clusterProbs)
        clusterAssign[i] <- cluster.i
        
        if (cluster.i > nClusters)
        {
          QQ = matrix(0,nClusters+1,nClusters+1)
          QQ[1:nClusters,1:nClusters] = Q
          QQ[nClusters+1,1:(nClusters+1)] = rbeta(nClusters+1,beta.a,beta.b)
          QQ[1:(nClusters+1),nClusters+1] = QQ[nClusters+1,1:(nClusters+1)]
          Q = QQ
          clusterSizes <- table(as.factor(clusterAssign)) # sorts according to labels
          nClusters <- length(clusterSizes)} else
          {Q = Q
           clusterSizes <- table(as.factor(clusterAssign))
           nClusters <- length(clusterSizes)}
        #update the parametre
        ##################################################################################
        ###############################################################
      } else {
        # a singleton, have |C| choices
        c.counts.noi = clusterSizes
        c.counts.noi[clusterAssign[i]] = c.counts.noi[clusterAssign[i]] - 1 - GAMMA# can offset the gamma adding later
        #finding the probs for sampling process
        clusterProbs = sapply(1:nClusters, function(x) {
          clusterAssign_temp = clusterAssign
          clusterAssign_temp[i] = x
          (GAMMA+c.counts.noi[x])*exp(loglike(clusterAssign_temp,Q,data,i,n))
        })
        clusterAssign_1 = clusterAssign
        clusterAssign_1[i] = nClusters+1
        clusterProbs[nClusters+1]<-GAMMA*exp(logmargs(clusterAssign_1,data,i,beta.a,beta.b))*exp(VN[nClusters]-VN[nClusters-1])
        #choose the cluster number for ith observation
        cluster.i <- sample(1:(nClusters+1), size = 1,
                            prob = clusterProbs)
        # remove the empty cluster
        if (cluster.i > nClusters)
        {      clusterAssign[i] <- cur.cluster.i #put the new cluster in the place of the only singleten one
               clusterSizes <- table(as.factor(clusterAssign)) # sorts according to labels
        } else
        {      
          clusterAssign[i] <- cluster.i
          clusterAssign <- ifelse(clusterAssign > cur.cluster.i, clusterAssign-1, clusterAssign) # to delete the previous group index
          clusterSizes <- table(as.factor(clusterAssign))
          nClusters <- length(clusterSizes) 
          if (nClusters > 1) {Q = Q[-cur.cluster.i,][,-cur.cluster.i]} else {Q = Q[-cur.cluster.i,][-cur.cluster.i]}}
        #update the parametre
        
      }
    }
    # end for loop over subjects i
    ##update Q
    Q = matrix(0, nClusters,nClusters)
    AA = matrix(0,nClusters,nClusters)
    NN = matrix(0,nClusters,nClusters)
    for (r in 1:nClusters){
      for (s in r:nClusters)
      {
        AA[r,s] = sum(data1[clusterAssign==r,clusterAssign==s]) + sum(data1[clusterAssign==s,clusterAssign==r])
        med = matrix(0,n,n)
        med[which(clusterAssign==r),which(clusterAssign==s)] = 1
        med1 = matrix(0,n,n)
        med1[which(clusterAssign==s),which(clusterAssign==r)] = 1
        NN[r,s] = sum(med*lower.tri(med)) + sum(med1*lower.tri(med1))
        Q[r,s] = rbeta(1,AA[r,s]+beta.a,NN[r,s]-AA[r,s]+beta.b)
        Q[s,r] = Q[r,s]
      }
    }
    History[[iter]] <- list(clusterAssign,Q)
    cat(" iteration:", iter,"\n",clusterAssign,"\n")
  }# for loop over iterations
  
  list(Iterates = History)
}

#CDMFM_new(A, AAA, niterations = 150, beta.a = 4, beta.b = 5, VN, GAMMA=1,initNClusters=1)


getDahl <- function(DPMMfit, burn = 2000)
{
  iters <- DPMMfit$Iterates[-(1:burn)]
  n <- length(iters[[1]][[1]])
  niters <- length(iters)
  membershipMatrices <- lapply(iters, function(x){
    clusterAssign <- x[[1]]
    outer(clusterAssign, clusterAssign, FUN = "==")
  })
  membershipAverage <- Reduce("+", membershipMatrices)/niters
  SqError <- sapply(membershipMatrices, function(x, av) sum((x - av)^2),
                    av = membershipAverage)
  DahlIndex <- which.min(SqError)
  DahlAns <- iters[[DahlIndex]]
  attr(DahlAns, "iterIndex") <- burn + DahlIndex
  attr(DahlAns, "burnin") <- burn
  DahlAns
}



Simulation_Comparenew <- function(n=100,kk=3,rho = 0.25,B=20,niterations,beta.a,beta.b,VN,GAMMA,NN,weight,initNClusters,times)
{
  ##data generation
  #   n = 100
  #   kk = 3
  K1 = NULL
  K2 = NULL
  K3 = NULL
  for (nn in 1:NN)
  {
    Z <- c(sample(1:kk, size = kk, replace = FALSE),
           sample(1:kk, size = n-kk, replace = TRUE,prob = weight))
    Z = Z[order(Z)]
    theta <- matrix(0.1,kk,kk)
    diag(theta) = rho
    A = matrix(0,n,n)
    AAA = matrix(0,n,n)
    for (i in 1:n){
      for (j in i:n){
        A[i,j] = rbinom(1,1,prob=theta[Z[i],Z[j]])
        A[j,i] = A[i,j]
        AAA[i,j] = A[i,j]
      }
    }
    diag(AAA) = 0
    diag(A) = 0
    
    MCR = sapply(1:times, function(x) {fita = CDMFM_new(A, AAA,niterations, beta.a, beta.b, VN, GAMMA,initNClusters)
                                   length(unique(getDahl(fita,burn = B)[[1]]))})
    K1[nn] = as.numeric(names(sort(-table(MCR)))[1])
    #NB
    D = matrix(0,n,n)
    diag(D) = colSums(A)
    B_tilta = matrix(0,2*n,2*n)
    B_tilta[1:n,1:n] = 0
    B_tilta[c(1:n),c((n+1):(2*n))] = D-diag(n)
    B_tilta[c((n+1):(2*n)),c((n+1):(2*n))] = A
    B_tilta[c((n+1):(2*n)),c(1:n)] = -diag(n)
    values = eigen(B_tilta, symmetric=FALSE, only.values = TRUE, EISPACK = FALSE)$values
    d_tilta = sqrt(1/(sum(colSums(A)))*(sum(colSums(A)^2))-1)
    K2[nn] = length(which(Im(values)==0 & Re(values)>d_tilta))
    #BHN
    D = matrix(0,n,n)
    diag(D) = colSums(A)
    d_tilta = sqrt(1/(sum(colSums(A)))*(sum(colSums(A)^2))-1)
    r = d_tilta
    Hr = (r^2-1)*diag(n)-r*A+D
    values_bhm = eigen(Hr, symmetric=TRUE, only.values = TRUE, EISPACK = FALSE)$values
    K3[nn] = sum(values_bhm<0)
  }
  list(K1,K2,K3)
}


Simulation_Comparenew(n=100,kk=3,rho = 0.35,B=20,niterations=100,beta.a=4,beta.b=5,VN=VN,GAMMA=1,NN=500,weight=rep(1,3),initNClusters=5,times = 20)

##using rand index to capture the performance

fit1 = CDMFM_new(A, AAA, niterations = 100, beta.a = 1, beta.b = 1, VN, GAMMA=1,15)
fit2 = CDMFM_new(A, AAA, niterations = 100, beta.a = 1, beta.b = 1, VN, GAMMA=1,15)
fit3 = CDMFM_new(A, AAA, niterations = 100, beta.a = 1, beta.b = 1, VN, GAMMA=1,15)
fit4 = CDMFM_new(A, AAA, niterations = 100, beta.a = 1, beta.b = 1, VN, GAMMA=1,15)
fit5 = CDMFM_new(A, AAA, niterations = 100, beta.a = 1, beta.b = 1, VN, GAMMA=1,15)


result1 = sapply(1:100, function(x) {adjustedRandIndex(fit1$Iterates[[x]][[1]],Z)})
result2 = sapply(1:100, function(x) {adjustedRandIndex(fit2$Iterates[[x]][[1]],Z)})
result3 = sapply(1:100, function(x) {adjustedRandIndex(fit3$Iterates[[x]][[1]],Z)})
result4 = sapply(1:100, function(x) {adjustedRandIndex(fit4$Iterates[[x]][[1]],Z)})
result5 = sapply(1:100, function(x) {adjustedRandIndex(fit5$Iterates[[x]][[1]],Z)})

par(mfrow=c(1,3),mai = c(0.9,0.9,0.9,0.1))

plot(c(1:100),result1,main = "k=5, n=200, p=0.4", ylim = c(0,1), xlab="Iterations", ylab="Rand Index", type = "l",font = 2, font.lab = 2, lty = 1,lwd = 2, cex.lab=2.5, cex.axis=2, cex.main=3)
lines(c(1:100),result2,type = "l", lty =1,lwd = 2, col = "red")
lines(c(1:100),result3,type = "l", lty =1,lwd=2, col = "blue")
lines(c(1:100),result4,type = "l", lty =1,lwd = 2,col = "green")
lines(c(1:100),result5,type = "l", lty =1,lwd = 2, col = "purple")

plot(c(1:100),result1,main = "K=3, n=100, p=0.5", ylim = c(0,1),xlab="Iterations", ylab="Rand Index",type = "l",lty = 1,cex.lab=1.5, cex.axis=1.5, cex.main=1.5)
lines(c(1:100),result2,type = "l", lty =1,col = "red")
lines(c(1:100),result3,type = "l", lty =1,col = "blue")
lines(c(1:100),result4,type = "l", lty =1,col = "green")
lines(c(1:100),result5,type = "l", lty =1,col = "yellow")


plot(c(1:100),result1,main = "K=5, n=100, p=0.4", ylim = c(0,1), xlab="Iterations", ylab="Rand Index",type = "l",lty = 1,cex.lab=1.5, cex.axis=1.5, cex.main=1.5)
lines(c(1:100),result2,type = "l", lty =1,col = "red")
lines(c(1:100),result3,type = "l", lty =1,col = "blue")
lines(c(1:100),result4,type = "l", lty =1,col = "green")
lines(c(1:100),result5,type = "l", lty =1,col = "yellow")



legend(-40,5.5, # places a legend at the appropriate place 
       c("Treated","Untreated"), cex=1,# puts text in the legend
       
       # gives the legend appropriate symbols (lines)
       
       lwd=c(1.5,1.5),lty = c(2,1))


hist(x, xlim=range(x),
     xlab= "Variable Lable", ylab="density", main="Title of plot", prob=TRUE, 
     cex.lab=1.5, cex.axis=1.5, cex.main=1.5, cex.sub=1.5)


